// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from dataspeed_dbw_gateway:msg/BoundedDynamicArrays.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_DBW_GATEWAY__MSG__DETAIL__BOUNDED_DYNAMIC_ARRAYS__FUNCTIONS_H_
#define DATASPEED_DBW_GATEWAY__MSG__DETAIL__BOUNDED_DYNAMIC_ARRAYS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "dataspeed_dbw_gateway/msg/rosidl_generator_c__visibility_control.h"

#include "dataspeed_dbw_gateway/msg/detail/bounded_dynamic_arrays__struct.h"

/// Initialize msg/BoundedDynamicArrays message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * dataspeed_dbw_gateway__msg__BoundedDynamicArrays
 * )) before or use
 * dataspeed_dbw_gateway__msg__BoundedDynamicArrays__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
bool
dataspeed_dbw_gateway__msg__BoundedDynamicArrays__init(dataspeed_dbw_gateway__msg__BoundedDynamicArrays * msg);

/// Finalize msg/BoundedDynamicArrays message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
void
dataspeed_dbw_gateway__msg__BoundedDynamicArrays__fini(dataspeed_dbw_gateway__msg__BoundedDynamicArrays * msg);

/// Create msg/BoundedDynamicArrays message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * dataspeed_dbw_gateway__msg__BoundedDynamicArrays__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
dataspeed_dbw_gateway__msg__BoundedDynamicArrays *
dataspeed_dbw_gateway__msg__BoundedDynamicArrays__create();

/// Destroy msg/BoundedDynamicArrays message.
/**
 * It calls
 * dataspeed_dbw_gateway__msg__BoundedDynamicArrays__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
void
dataspeed_dbw_gateway__msg__BoundedDynamicArrays__destroy(dataspeed_dbw_gateway__msg__BoundedDynamicArrays * msg);


/// Initialize array of msg/BoundedDynamicArrays messages.
/**
 * It allocates the memory for the number of elements and calls
 * dataspeed_dbw_gateway__msg__BoundedDynamicArrays__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
bool
dataspeed_dbw_gateway__msg__BoundedDynamicArrays__Sequence__init(dataspeed_dbw_gateway__msg__BoundedDynamicArrays__Sequence * array, size_t size);

/// Finalize array of msg/BoundedDynamicArrays messages.
/**
 * It calls
 * dataspeed_dbw_gateway__msg__BoundedDynamicArrays__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
void
dataspeed_dbw_gateway__msg__BoundedDynamicArrays__Sequence__fini(dataspeed_dbw_gateway__msg__BoundedDynamicArrays__Sequence * array);

/// Create array of msg/BoundedDynamicArrays messages.
/**
 * It allocates the memory for the array and calls
 * dataspeed_dbw_gateway__msg__BoundedDynamicArrays__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
dataspeed_dbw_gateway__msg__BoundedDynamicArrays__Sequence *
dataspeed_dbw_gateway__msg__BoundedDynamicArrays__Sequence__create(size_t size);

/// Destroy array of msg/BoundedDynamicArrays messages.
/**
 * It calls
 * dataspeed_dbw_gateway__msg__BoundedDynamicArrays__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dataspeed_dbw_gateway
void
dataspeed_dbw_gateway__msg__BoundedDynamicArrays__Sequence__destroy(dataspeed_dbw_gateway__msg__BoundedDynamicArrays__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // DATASPEED_DBW_GATEWAY__MSG__DETAIL__BOUNDED_DYNAMIC_ARRAYS__FUNCTIONS_H_
